#DEFINE Leer    32
#DEFINE Wand    35
#DEFINE Spieler 83
ENUM Richtung
  Links = 0, Oben, Rechts, Unten
END ENUM

DIM AS INTEGER felddata(24, 24), cx, cy, f = FREEFILE
DIM AS Richtung cr = Rechts
DIM AS STRING zeile
DECLARE SUB bewege(BYREF x AS INTEGER, BYREF y AS INTEGER, r AS Richtung)

SCREENRES 200, 200
RANDOMIZE TIMER

' Daten einlesen
IF OPEN("spieldaten.txt" FOR INPUT AS #f) <> 0 THEN
  PRINT "Die Datei spieldaten.txt wurde nicht gefunden!"
  GETKEY
  END
END IF
FOR y AS INTEGER = 0 TO 24
  LINE INPUT #f, zeile
  IF LEN(zeile) <> 25 THEN
    PRINT "Fehler in der Datei spieldaten.txt"
    GETKEY
    END
  END IF
  FOR x AS INTEGER = 0 TO 24
    felddata(x, y) = zeile[x]
    DRAW STRING (x*8, y*8), CHR(felddata(x, y))
    IF zeile[x] = Spieler THEN
      felddata(x, y) = Leer
      cx = x
      cy = y
    END IF
  NEXT
NEXT

' Computerzuege
DO
  ' Vorwaertszug testen
  SELECT CASE cr
    CASE Links
      IF felddata(cx-1, cy) = Leer THEN bewege cx, cy, Links  : CONTINUE DO
    CASE Oben
      IF felddata(cx, cy-1) = Leer THEN bewege cx, cy, Oben   : CONTINUE DO
    CASE Rechts
      IF felddata(cx+1, cy) = Leer THEN bewege cx, cy, Rechts : CONTINUE DO
    CASE Unten
      IF felddata(cx, cy+1) = Leer THEN bewege cx, cy, Unten  : CONTINUE DO
  END SELECT
  
  ' verfuegbare Richtungen suchen
  DIM AS INTEGER linksabbiegen = 0, rechtsabbiegen = 0
  SELECT CASE cr
    CASE Links
      IF felddata(cx, cy+1) = Leer THEN linksabbiegen = -1
      IF felddata(cx, cy-1) = Leer THEN rechtsabbiegen = -1
    CASE Oben
      IF felddata(cx-1, cy) = Leer THEN linksabbiegen = -1
      IF felddata(cx+1, cy) = Leer THEN rechtsabbiegen = -1
    CASE Rechts
      IF felddata(cx, cy-1) = Leer THEN linksabbiegen = -1
      IF felddata(cx, cy+1) = Leer THEN rechtsabbiegen = -1
    CASE Unten
      IF felddata(cx+1, cy) = Leer THEN linksabbiegen = -1
      IF felddata(cx-1, cy) = Leer THEN rechtsabbiegen = -1
  END SELECT
  IF linksabbiegen AND (NOT rechtsabbiegen) THEN      ' nur linksabbiegen
    cr = (cr+3) MOD 4
  ELSEIF (NOT linksabbiegen) AND rechtsabbiegen THEN  ' nur rechtsabbiegen
    cr = (cr+1) MOD 4
  ELSEIF linksabbiegen AND rechtsabbiegen THEN        ' beides moeglich
    ' zu 50% links, zu 50% rechts abbiegen
    IF RND < .5 THEN cr = (cr+3) MOD 4 ELSE cr = (cr+1) MOD 4
  ELSE                                                ' keines moeglich
    cr = (cr+2) MOD 4
  END IF
LOOP UNTIL INKEY <> ""

SUB bewege(BYREF x AS INTEGER, BYREF y AS INTEGER, r AS Richtung)
  LINE (x*8, y*8)-STEP(8, 8), 0, BF  ' alte Position loeschen
  SELECT CASE r
    CASE Links  : x -= 1
    CASE Oben   : y -= 1
    CASE Rechts : x += 1
    CASE Unten  : y += 1
  END SELECT
  DRAW STRING (x*8, y*8), "S"        ' neue Position schreiben
  SLEEP 200, 1                       ' Pause
END SUB
